org.apache.commons.math3.optimization.general

## Enum ConjugateGradientFormula

- java.lang.Object
- - java.lang.Enum<ConjugateGradientFormula>
  - - org.apache.commons.math3.optimization.general.ConjugateGradientFormula

- All Implemented Interfaces:
    Serializable, Comparable<ConjugateGradientFormula>

      public enum ConjugateGradientFormula
      extends Enum<ConjugateGradientFormula>

  Available choices of update formulas for the β parameter in `NonLinearConjugateGradientOptimizer`.

  The β parameter is used to compute the successive conjugate search directions. For non-linear conjugate gradients, there are two formulas to compute β:

  - Fletcher-Reeves formula
  - Polak-Ribière formula
  On the one hand, the Fletcher-Reeves formula is guaranteed to converge if the start point is close enough of the optimum whether the Polak-Ribière formula may not converge in rare cases. On the other hand, the Polak-Ribière formula is often faster when it does converge. Polak-Ribière is often used.

  Since:
    2.0
  Version:
    $Id: ConjugateGradientFormula.java 1244107 2012-02-14 16:17:55Z erans $
  See Also:
    `NonLinearConjugateGradientOptimizer`

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `FLETCHER_REEVES` Fletcher-Reeves formula.
    `POLAK_RIBIERE` Polak-Ribière formula.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static ConjugateGradientFormula` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static ConjugateGradientFormula[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### FLETCHER_REEVES

          public static final ConjugateGradientFormula FLETCHER_REEVES

      Fletcher-Reeves formula.

    - #### POLAK_RIBIERE

          public static final ConjugateGradientFormula POLAK_RIBIERE

      Polak-Ribière formula.

  - ### Method Detail

    - #### values

          public static ConjugateGradientFormula[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ConjugateGradientFormula c : ConjugateGradientFormula.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ConjugateGradientFormula valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

Copyright © 2003-2012 The Apache Software Foundation. All Rights Reserved.